"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = void 0;
const dataconnectEmulator_1 = require("../emulator/dataconnectEmulator");
const error_1 = require("../error");
const graphqlError_1 = require("./graphqlError");
async function build(options, configDir) {
    var _a, _b, _c;
    const projectId = (_a = options.project) !== null && _a !== void 0 ? _a : "demo-test";
    const args = {
        projectId,
        configDir,
        auto_download: true,
        rc: options.rc,
    };
    const dataconnectEmulator = new dataconnectEmulator_1.DataConnectEmulator(args);
    const buildResult = await dataconnectEmulator.build();
    if ((_b = buildResult === null || buildResult === void 0 ? void 0 : buildResult.errors) === null || _b === void 0 ? void 0 : _b.length) {
        throw new error_1.FirebaseError(`There are errors in your schema and connector files:\n${buildResult.errors.map(graphqlError_1.prettify).join("\n")}`);
    }
    return (_c = buildResult === null || buildResult === void 0 ? void 0 : buildResult.metadata) !== null && _c !== void 0 ? _c : {};
}
exports.build = build;
