"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeGraphQL = void 0;
const api_1 = require("../api");
const apiv2_1 = require("../apiv2");
const DATACONNECT_API_VERSION = "v1alpha";
const dataconnectDataplaneClient = () => new apiv2_1.Client({
    urlPrefix: (0, api_1.dataconnectOrigin)(),
    apiVersion: DATACONNECT_API_VERSION,
    auth: true,
});
async function executeGraphQL(servicePath, body) {
    const res = await dataconnectDataplaneClient().post(`${servicePath}:executeGraphql`, body, { resolveOnHTTPError: true });
    return res;
}
exports.executeGraphQL = executeGraphQL;
