"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printFreeTrialUnavailable = exports.checkForFreeTrialInstance = exports.freeTrialTermsLink = void 0;
const cloudsqladmin_1 = require("../gcp/cloudsql/cloudsqladmin");
const utils = require("../utils");
function freeTrialTermsLink() {
    return "https://firebase.google.com/pricing";
}
exports.freeTrialTermsLink = freeTrialTermsLink;
async function checkForFreeTrialInstance(projectId) {
    var _a;
    const instances = await (0, cloudsqladmin_1.listInstances)(projectId);
    return (_a = instances.find((i) => { var _a; return ((_a = i.settings.userLabels) === null || _a === void 0 ? void 0 : _a["firebase-data-connect"]) === "ft"; })) === null || _a === void 0 ? void 0 : _a.name;
}
exports.checkForFreeTrialInstance = checkForFreeTrialInstance;
function printFreeTrialUnavailable(projectId, instanceId) {
    const message = `Project '${projectId}' already has a CloudSQL instance '${instanceId}' on the Firebase Data Connect free trial. ` +
        "The free trial only includes one CloudSQL instance. " +
        `Consider using a separate database on ${instanceId}, or creating a new CloudSQL instance at ` +
        "https://console.cloud.google.com/sql/instances";
    utils.logLabeledError("dataconnect", message);
}
exports.printFreeTrialUnavailable = printFreeTrialUnavailable;
